/*
 GNU Maverik - a system for managing display and interaction in 
               Virtual Environment applications.
 Copyright (C) 1999-2002 Advanced Interfaces Group

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


 The authors can be contacted via:
 www   - http://aig.cs.man.ac.uk
 email - maverik@aig.cs.man.ac.uk
 mail  - Advanced Interfaces Group, Room 2.94, Kilburn Building, 
         University of Manchester, Manchester, M13 9PL, UK
*/

#ifndef _MAV_NEAREST_POINT_INCLUDE
#define _MAV_NEAREST_POINT_INCLUDE

#ifdef MAVAPI
#undef MAVAPI
#endif
#if defined(WIN32) && !defined(__CYGWIN__) 
#ifdef LIBMAV_FFNAV_EXPORTS
#define MAVAPI __declspec(dllexport) 
#else
#define MAVAPI __declspec(dllimport) 
#endif
#else
#define MAVAPI 
#endif

#ifdef __cplusplus
extern "C" {
#endif

MAVAPI extern MAV_callback *mav_callback_nearestPoint;
typedef int (*MAV_callbackNearestPointFn) (MAV_object *, MAV_person *, MAV_vector *);
MAVAPI void mav_callbackNearestPointSet(MAV_window *, MAV_class *, MAV_callbackNearestPointFn);
MAVAPI int mav_callbackNearestPointExec(MAV_window *, MAV_object *, MAV_person *, MAV_vector *);

MAVAPI int mav_BBNearestPoint(MAV_BB bb, MAV_person *the_user, MAV_vector *pt);
MAVAPI void mav_lineNearestPoint(float x, float y, float z, float x1, float y1, float z1, float x2, float y2, float z2, float *current, MAV_vector *point);
MAVAPI void mav_vertsNearestPoint(MAV_person *the_user, MAV_vector *verts, int nv, float *current, MAV_vector *pt);

MAVAPI int mav_boxNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_pyramidNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_cylinderNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_coneNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_sphereNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_hsphereNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_ellipseNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_hellipseNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_ctorusNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_rtorusNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_polygonNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);
MAVAPI int mav_facetNearestPoint(MAV_object *obj, MAV_person *the_user, MAV_vector *pt);

MAVAPI void mav_nearestPointInit(void);

#ifdef __cplusplus
}
#endif
#endif

